manjaro-tools/bin/mkchroot.in

120 lines
3.2 KiB
Text
Raw Normal View History

2014-10-04 00:46:40 +02:00
#!/bin/bash
2014-11-18 19:20:53 +01:00
#
2014-10-04 00:46:40 +02:00
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
2014-10-08 13:14:28 +02:00
version=@version@
2015-06-09 00:01:31 +02:00
LIBDIR='@libdir@'
import ${LIBDIR}/util-msg.sh
2015-06-09 00:01:31 +02:00
import ${LIBDIR}/util.sh
2017-04-19 21:30:38 +02:00
import ${LIBDIR}/util-chroot.sh
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
working_dir=''
files=()
2015-01-02 18:26:27 +01:00
build_locales=false
2015-06-03 17:53:13 +02:00
keep_mirrors=false
2015-06-03 18:25:31 +02:00
keep_flag=''
nosetarch=false
branch=stable
2014-10-04 00:46:40 +02:00
usage() {
2016-09-15 23:58:18 +02:00
echo "Usage: ${0##*/} [options] working-dir package-list..."
echo ' options:'
echo ' -C <file> Location of a pacman config file'
echo ' -M <file> Location of a makepkg config file'
echo ' -B <branch> Set branch'
echo ' -U <url> Set a specific mirror'
2016-09-15 23:58:18 +02:00
echo ' -c <dir> Set pacman cache'
echo ' -f <file> Copy file from the host to the chroot'
echo ' -s Do not run setarch'
2016-09-15 23:58:18 +02:00
echo ' -h This message'
exit 1
2014-10-04 00:46:40 +02:00
}
orig_argv=("$0" "$@")
2014-11-12 02:19:58 +01:00
opts='hC:M:U:B:c:f:s'
while getopts ${opts} arg; do
2016-09-15 23:58:18 +02:00
case "${arg}" in
2017-06-06 17:58:43 +02:00
C) pacman_conf="$OPTARG" ;;
2016-09-15 23:58:18 +02:00
M) makepkg_conf="$OPTARG" ;;
2017-06-04 23:07:16 +02:00
B) branch="$OPTARG" ;;
U) mirror="$OPTARG" ;;
2016-09-15 23:58:18 +02:00
c) cache_dir="$OPTARG" ;;
f) files+=("$OPTARG") ;;
s) nosetarch=true ;;
2016-09-15 23:58:18 +02:00
h|?) usage ;;
*) error "invalid argument '%s'" "$arg"; usage ;;
2016-09-15 23:58:18 +02:00
esac
2014-10-04 00:46:40 +02:00
done
shift $(($OPTIND - 1))
2014-11-11 21:19:26 +01:00
(( $# < 2 )) && die 'You must specify a directory and one or more packages.'
2014-10-04 00:46:40 +02:00
check_root
2014-11-11 21:19:26 +01:00
2014-11-12 02:19:58 +01:00
working_dir="$(readlink -f $1)"
2014-11-11 21:19:26 +01:00
shift 1
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
[[ -z $working_dir ]] && die 'Please specify a working directory.'
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
if [[ -z $cache_dir ]]; then
2016-09-15 23:58:18 +02:00
cache_dirs=($(pacman -v $cache_conf 2>&1 | grep '^Cache Dirs:' | sed 's/Cache Dirs:\s*//g'))
2014-11-12 02:19:58 +01:00
else
2016-09-15 23:58:18 +02:00
cache_dirs=(${cache_dir})
2014-11-12 02:19:58 +01:00
fi
2014-10-04 00:46:40 +02:00
2017-06-06 17:58:43 +02:00
basestrap_args=(-GMcd ${pacman_conf:+-C "$pacman_conf"} -B "${branch}")
[[ -n ${mirror} ]] && basestrap_args+=(-U "${mirror}")
2014-11-12 02:19:58 +01:00
umask 0022
2014-10-04 00:46:40 +02:00
#[[ -e $working_dir ]] && die "Working directory '%s' already exists" "$working_dir"
2014-10-04 00:46:40 +02:00
#mkdir -p "$working_dir"
2015-01-15 13:23:34 +01:00
[[ ! -d $working_dir ]] && mkdir -p "$working_dir"
2014-10-04 00:46:40 +02:00
2014-11-12 02:19:58 +01:00
lock 9 "${working_dir}.lock" "Locking chroot"
2014-10-04 00:46:40 +02:00
if is_btrfs "$working_dir"; then
rmdir "$working_dir"
if ! btrfs subvolume create "$working_dir"; then
die "Couldn't create subvolume for '%s'" "$working_dir"
fi
chmod 0755 "$working_dir"
2014-11-12 02:19:58 +01:00
fi
2014-10-04 00:46:40 +02:00
2017-06-06 17:58:43 +02:00
for f in "${files[@]}"; do
mkdir -p "$(dirname "$working_dir$f")"
cp "$f" "$working_dir$f"
done
_env=()
while read -r varname; do
_env+=("$varname=${!varname}")
done < <(declare -x | sed -r 's/^declare -x ([^=]*)=.*/\1/' | grep -i '_proxy$')
env -i "${_env[@]}" \
basestrap "${basestrap_args[@]}" "$working_dir" ${cache_dirs[@]/#/--cachedir=} "$@" || die 'Failed to install all packages'
echo "$version" > "$working_dir/.manjaro-tools"
2015-01-11 21:02:29 +01:00
set_locale "$working_dir"
2017-06-06 17:58:43 +02:00
chroot_args=(${pacman_conf:+-C "$pacman_conf"} ${makepkg_conf:+-M "$makepkg_conf"} ${cache_dir:+-c "$cache_dir"})
${nosetarch} && chroot_args+=(${nosetarch:+-s})
2015-01-11 21:02:29 +01:00
exec chroot-run \
2016-09-15 23:58:18 +02:00
${chroot_args[*]} \
"$working_dir" locale-gen